(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     13787,        382]
NotebookOptionsPosition[     11260,        331]
NotebookOutlinePosition[     11854,        354]
CellTagsIndexPosition[     11768,        349]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "\"\<OperatorGB.m\>\""}]}], "Input",
 CellChangeTimes->{{3.774860911280286*^9, 3.774860925931706*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"b70eb990-e8ff-4d45-9230-07486bcc2fed"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Package OperatorGB version 1.0.1\\nCopyright 2019, \
Institute of Algebra, JKU\\nwritten by Clemens Hofstadler\"\>"], "Print",
 CellChangeTimes->{3.774860926939904*^9, 3.774861317382872*^9, 
  3.774861358685175*^9},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"211446f5-6bf8-445c-9ae5-b1d36aab6447"],

Cell[BoxData["\<\"A few definitions need to be made by the user. Type \
?SetUpRing for more information.\"\>"], "Print", "PrintUsage",
 CellChangeTimes->{3.774861358820999*^9},
 CellTags->
  "Info23774868558-8309162",ExpressionUUID->"aee39482-3fdc-416d-87f8-\
a80802ea77a0"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["1st example", "Section",
 CellChangeTimes->{{3.7748621512397957`*^9, 
  3.774862178670738*^9}},ExpressionUUID->"abf43dd3-2579-4feb-9d64-\
d53b48928a56"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"assumption", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "**", 
      SuperscriptBox["a", "-"], "**", "a"}], "-", "a"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"claim", " ", "=", " ", 
   RowBox[{
    RowBox[{"a", "**", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["a", "-"], "+", "y", "-", 
       RowBox[{"y", "**", "a", "**", 
        SuperscriptBox["a", "-"]}]}], ")"}], "**", "a"}], " ", "-", "a"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Q", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "V", ",", "W"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox["a", "-"], ",", "W", ",", "V"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", "W", ",", "V"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"PlotQuiver", "[", "Q", "]"}]}], "Input",
 CellChangeTimes->{{3.774860950652042*^9, 3.774861060800686*^9}, {
  3.77486109427269*^9, 3.774861114494997*^9}, {3.774862430357854*^9, 
  3.774862439074665*^9}},
 CellLabel->"In[41]:=",ExpressionUUID->"0802089f-2e16-4c77-859c-d8b4854cd6db"],

Cell[BoxData[
 RowBox[{
  RowBox[{"certificate", " ", "=", " ", 
   RowBox[{"Certify", "[", 
    RowBox[{"assumption", ",", "claim", ",", "Q"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.7748610532940617`*^9, 3.7748610547946777`*^9}, {
  3.774861126600731*^9, 3.774861164839838*^9}, {3.774861366487626*^9, 
  3.774861367328804*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"916fb1d9-9429-49c7-bd98-f35bb18ce5ff"],

Cell[BoxData[
 RowBox[{"certificate", "[", 
  RowBox[{"[", 
   RowBox[{";;", "3"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.774861369730928*^9, 3.7748613731126947`*^9}, {
  3.774862346543434*^9, 3.77486234667444*^9}},
 CellLabel->"In[36]:=",ExpressionUUID->"397d3fea-2478-4fc8-b286-a79ed9a76415"],

Cell[BoxData[
 RowBox[{"certificate", "[", 
  RowBox[{"[", "4", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.774861379852103*^9, 3.774861381957323*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"3768dc82-225f-497e-a3b7-7c9a07116f31"]
}, Closed]],

Cell[CellGroupData[{

Cell["2nd example", "Section",
 CellChangeTimes->{{3.774862172238737*^9, 
  3.774862174037867*^9}},ExpressionUUID->"71ab49a6-6e82-4dfb-8fe4-\
ff4b6f4d2d85"],

Cell["\<\
Same as 1st example only that operator a now acts on different spaces. We \
only have to change the quiver. The obtained signatures of the input \
polynomials change but the cofactor representation remains the same.\
\>", "Text",
 CellChangeTimes->{{3.774862197765011*^9, 3.774862232281748*^9}, {
  3.774862311434526*^9, 3.774862323984334*^9}, {3.774862357895644*^9, 
  3.7748623731909723`*^9}},ExpressionUUID->"d14b7975-8ddb-4c8b-87fb-\
180834d51acb"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Q", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "V", ",", "W"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox["a", "-"], ",", "W", ",", "V"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", "W", ",", "V"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "U", ",", "W"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"PlotQuiver", "[", "Q", "]"}]}], "Input",
 CellChangeTimes->{{3.77486218332093*^9, 3.774862183619163*^9}, {
  3.774862233842301*^9, 3.774862240053198*^9}, {3.774862272813799*^9, 
  3.774862294499852*^9}},
 CellLabel->"In[26]:=",ExpressionUUID->"30a60263-7cca-4355-a89a-484acd5386bc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"certificate", " ", "=", " ", 
   RowBox[{"Certify", "[", 
    RowBox[{"assumption", ",", "claim", ",", "Q"}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[28]:=",ExpressionUUID->"4ab1cc3a-094c-4d8f-8e6d-808da028197d"],

Cell[BoxData[
 RowBox[{"certificate", "[", 
  RowBox[{"[", 
   RowBox[{";;", "3"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.7748622992459507`*^9, 3.774862302179755*^9}, {
  3.774862337463335*^9, 3.774862338954279*^9}},
 CellLabel->"In[31]:=",ExpressionUUID->"1876c385-7d0d-4e40-91bd-f2b607348d97"],

Cell[BoxData[
 RowBox[{"certificate", "[", 
  RowBox[{"[", "4", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.774862303377063*^9, 3.774862305559827*^9}},
 CellLabel->"In[30]:=",ExpressionUUID->"6524360e-ca2d-4543-bfce-82bfbd56f225"]
}, Closed]],

Cell[CellGroupData[{

Cell["3rd example", "Section",
 CellChangeTimes->{{3.774862389518186*^9, 
  3.77486239116084*^9}},ExpressionUUID->"11f542ae-f1ad-4f8d-b125-\
1ef6e370064d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"assumptions", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"a", "**", 
       SuperscriptBox["a", "-"], "**", "a"}], "-", "a"}], ",", 
     RowBox[{
      RowBox[{"a", "**", 
       SuperscriptBox["a", "-"], "**", "y", "**", "b", "**", "z"}], " ", "-", 
      
      RowBox[{"y", "**", "b", "**", "z"}]}], ",", 
     RowBox[{
      RowBox[{"y", "**", "b", "**", "z", "**", 
       SuperscriptBox["a", "-"], "**", "a"}], "-", 
      RowBox[{"y", "**", "b", "**", "z"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "+", 
         RowBox[{"b", "**", "z", "**", 
          SuperscriptBox["a", "-"], "**", "y", "**", "b"}]}], ")"}], "**", 
       SuperscriptBox["s", "-"], "**", 
       RowBox[{"(", 
        RowBox[{"b", "+", 
         RowBox[{"b", "**", "z", "**", 
          SuperscriptBox["a", "-"], "**", "y", "**", "b"}]}], ")"}]}], "-", 
      RowBox[{"(", 
       RowBox[{"b", "+", 
        RowBox[{"b", "**", "z", "**", 
         SuperscriptBox["a", "-"], "**", "y", "**", "b"}]}], ")"}]}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"claim", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"y", "**", "b", "**", "z"}]}], ")"}], "**", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["a", "-"], "-", 
       RowBox[{
        SuperscriptBox["a", "-"], "**", "y", "**", "b", "**", 
        SuperscriptBox["s", "-"], "**", "b", "**", "z", "**", 
        SuperscriptBox["a", "-"]}]}], ")"}], "**", 
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"y", "**", "b", "**", "z"}]}], ")"}]}], "-", 
    RowBox[{"(", 
     RowBox[{"a", "+", 
      RowBox[{"y", "**", "b", "**", "z"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Q", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", 
       SubscriptBox["V", "1"], ",", 
       SubscriptBox["V", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox["a", "-"], ",", 
       SubscriptBox["V", "2"], ",", 
       SubscriptBox["V", "1"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"b", ",", 
       SubscriptBox["V", "3"], ",", 
       SubscriptBox["V", "4"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox["s", "-"], ",", 
       SubscriptBox["V", "4"], ",", 
       SubscriptBox["V", "3"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", 
       SubscriptBox["V", "4"], ",", 
       SubscriptBox["V", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"z", ",", 
       SubscriptBox["V", "1"], ",", 
       SubscriptBox["V", "3"]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"PlotQuiver", "[", "Q", "]"}]}], "Input",
 CellChangeTimes->{{3.774861505894796*^9, 3.774861668783697*^9}, {
  3.774862453256673*^9, 
  3.774862457215476*^9}},ExpressionUUID->"4425d079-017f-43db-917f-\
a640822dc872"],

Cell[BoxData[
 RowBox[{
  RowBox[{"certificate", " ", "=", " ", 
   RowBox[{"Certify", "[", 
    RowBox[{"assumptions", ",", "claim", ",", "Q", ",", 
     RowBox[{"Info", "\[Rule]", "True"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.774861851035371*^9, 3.7748618654509172`*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"950e56d0-ff7f-45b2-96df-bdd0e4e48681"],

Cell[BoxData[
 RowBox[{"certificate", "[", 
  RowBox[{"[", 
   RowBox[{";;", "3"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.774861875530324*^9, 3.7748618774907923`*^9}, {
  3.77486246653586*^9, 3.7748624666532516`*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"c22e10b8-7975-4adf-b340-9d963faef0cc"],

Cell[TextData[{
 "We perform some simplifications on the output such as collecting cofactors. \
Furthermore, we denote the assumptions by ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["f", "i"], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "ca1a9d8d-0eaf-4dd7-942a-d98d41e1c118"],
 " (as in the paper)."
}], "Text",
 CellChangeTimes->{{3.7748624769228897`*^9, 
  3.774862534499064*^9}},ExpressionUUID->"2c5c94fd-c09e-44cb-8548-\
74e7c980df4d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"certificate", "[", 
     RowBox[{"[", "4", "]"}], "]"}], "/.", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"ToNonCommutativeMultiply", "[", 
        RowBox[{"ToProd", "[", 
         RowBox[{"assumptions", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "\[Rule]", 
       SubscriptBox["f", "i"]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"Length", "[", "assumptions", "]"}]}], "}"}]}], "]"}]}], "//",
    "CollectLeft"}], "//", "CollectRight"}]], "Input",
 CellChangeTimes->{{3.774861878728697*^9, 3.7748619212064857`*^9}, {
  3.774861982545334*^9, 3.774861987005158*^9}, {3.7748620504388657`*^9, 
  3.7748620597211943`*^9}},
 CellLabel->"In[21]:=",ExpressionUUID->"92e49f3a-87e5-4cbd-b0c6-defa2f19511e"]
}, Closed]]
},
WindowSize->{808, 853},
WindowMargins->{{Automatic, 93}, {Automatic, 17}},
Magnification:>1.5 Inherited,
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info23774868558-8309162"->{
  Cell[1282, 41, 274, 5, 103, "Print",ExpressionUUID->"aee39482-3fdc-416d-87f8-a80802ea77a0",
   CellTags->"Info23774868558-8309162"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info23774868558-8309162", 11609, 343}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 337, 7, 78, "Input",ExpressionUUID->"b70eb990-e8ff-4d45-9230-07486bcc2fed"],
Cell[CellGroupData[{
Cell[942, 33, 337, 6, 95, "Print",ExpressionUUID->"211446f5-6bf8-445c-9ae5-b1d36aab6447"],
Cell[1282, 41, 274, 5, 103, "Print",ExpressionUUID->"aee39482-3fdc-416d-87f8-a80802ea77a0",
 CellTags->"Info23774868558-8309162"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1605, 52, 158, 3, 101, "Section",ExpressionUUID->"abf43dd3-2579-4feb-9d64-d53b48928a56"],
Cell[1766, 57, 1178, 34, 140, "Input",ExpressionUUID->"0802089f-2e16-4c77-859c-d8b4854cd6db"],
Cell[2947, 93, 417, 8, 46, "Input",ExpressionUUID->"916fb1d9-9429-49c7-bd98-f35bb18ce5ff"],
Cell[3367, 103, 302, 6, 46, "Input",ExpressionUUID->"397d3fea-2478-4fc8-b286-a79ed9a76415"],
Cell[3672, 111, 232, 4, 46, "Input",ExpressionUUID->"3768dc82-225f-497e-a3b7-7c9a07116f31"]
}, Closed]],
Cell[CellGroupData[{
Cell[3941, 120, 156, 3, 78, "Section",ExpressionUUID->"71ab49a6-6e82-4dfb-8fe4-ff4b6f4d2d85"],
Cell[4100, 125, 462, 8, 157, "Text",ExpressionUUID->"d14b7975-8ddb-4c8b-87fb-180834d51acb"],
Cell[4565, 135, 733, 19, 78, "Input",ExpressionUUID->"30a60263-7cca-4355-a89a-484acd5386bc"],
Cell[5301, 156, 249, 5, 46, "Input",ExpressionUUID->"4ab1cc3a-094c-4d8f-8e6d-808da028197d"],
Cell[5553, 163, 303, 6, 46, "Input",ExpressionUUID->"1876c385-7d0d-4e40-91bd-f2b607348d97"],
Cell[5859, 171, 232, 4, 46, "Input",ExpressionUUID->"6524360e-ca2d-4543-bfce-82bfbd56f225"]
}, Closed]],
Cell[CellGroupData[{
Cell[6128, 180, 155, 3, 78, "Section",ExpressionUUID->"11f542ae-f1ad-4f8d-b125-1ef6e370064d"],
Cell[6286, 185, 2975, 89, 357, "Input",ExpressionUUID->"4425d079-017f-43db-917f-a640822dc872"],
Cell[9264, 276, 366, 7, 78, "Input",ExpressionUUID->"950e56d0-ff7f-45b2-96df-bdd0e4e48681"],
Cell[9633, 285, 304, 6, 46, "Input",ExpressionUUID->"c22e10b8-7975-4adf-b340-9d963faef0cc"],
Cell[9940, 293, 467, 12, 123, "Text",ExpressionUUID->"2c5c94fd-c09e-44cb-8548-74e7c980df4d"],
Cell[10410, 307, 834, 21, 171, "Input",ExpressionUUID->"92e49f3a-87e5-4cbd-b0c6-defa2f19511e"]
}, Closed]]
}
]
*)

